# Source code for azure.mgmt.apimanagement.operations.reports_operations

    # coding=utf-8
    # --------------------------------------------------------------------------
    # Copyright (c) Microsoft Corporation. All rights reserved.
    # Licensed under the MIT License. See License.txt in the project root for
    # license information.
    #
    # Code generated by Microsoft (R) AutoRest Code Generator.
    # Changes may cause incorrect behavior and will be lost if the code is
    # regenerated.
    # --------------------------------------------------------------------------

    import uuid
    from msrest.pipeline import ClientRawResponse
    from msrestazure.azure_exceptions import CloudError

    from .. import models

    class ReportsOperations(object):
        """ReportsOperations operations.

        :param client: Client for service requests.
        :param config: Configuration of service client.
        :param serializer: An object model serializer.
        :param deserializer: An object model deserializer.
        :ivar api_version: Version of the API to be used with the client request. Constant value: "2019-01-01".
        """

        models = models

        def __init__(self, client, config, serializer, deserializer):

            self._client = client
            self._serialize = serializer
            self._deserialize = deserializer
            self.api_version = "2019-01-01"

            self.config = config

        def list_by_api(
                self, resource_group_name, service_name, filter, top=None, skip=None, orderby=None, custom_headers=None, raw=False, **operation_config):
            """Lists report records by API.

            :param resource_group_name: The name of the resource group.
            :type resource_group_name: str
            :param service_name: The name of the API Management service.
            :type service_name: str
            :param filter: The filter to apply on the operation.
            :type filter: str
            :param top: Number of records to return.
            :type top: int
            :param skip: Number of records to skip.
            :type skip: int
            :param orderby: OData order by query option.
            :type orderby: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of ReportRecordContract
            :rtype:
             ~azure.mgmt.apimanagement.models.ReportRecordContractPaged[~azure.mgmt.apimanagement.models.ReportRecordContract]
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list_by_api.metadata['url']
                    path_format_arguments = {
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                        'serviceName': self._serialize.url("service_name", service_name, 'str', max_length=50, min_length=1, pattern=r'^[a-zA-Z](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?$'),
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    query_parameters['$filter'] = self._serialize.query("filter", filter, 'str')
                    if top is not None:
                        query_parameters['$top'] = self._serialize.query("top", top, 'int', minimum=1)
                    if skip is not None:
                        query_parameters['$skip'] = self._serialize.query("skip", skip, 'int', minimum=0)
                    if orderby is not None:
                        query_parameters['$orderby'] = self._serialize.query("orderby", orderby, 'str')
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Accept'] = 'application/json'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters, header_parameters)
                response = self._client.send(request, stream=False, **operation_config)

                if response.status_code not in [200]:
                    exp = CloudError(response)
                    exp.request_id = response.headers.get('x-ms-request-id')
                    raise exp

                return response

            # Deserialize response
            deserialized = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list_by_api.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ApiManagement/service/{serviceName}/reports/byApi'}

        def list_by_user(
                self, resource_group_name, service_name, filter, top=None, skip=None, orderby=None, custom_headers=None, raw=False, **operation_config):
            """Lists report records by User.

            :param resource_group_name: The name of the resource group.
            :type resource_group_name: str
            :param service_name: The name of the API Management service.
            :type service_name: str
            :param filter: |   Field     |     Usage     |     Supported operators
             |     Supported functions
             |</br>|-------------|-------------|-------------|-------------|</br>|
             timestamp | filter | ge, le |     | </br>| displayName | select,
             orderBy |     |     | </br>| userId | select, filter | eq |     |
             </br>| apiRegion | filter | eq |     | </br>| productId | filter | eq
             |     | </br>| subscriptionId | filter | eq |     | </br>| apiId |
             filter | eq |     | </br>| operationId | filter | eq |     | </br>|
             callCountSuccess | select, orderBy |     |     | </br>|
             callCountBlocked | select, orderBy |     |     | </br>|
             callCountFailed | select, orderBy |     |     | </br>| callCountOther
             | select, orderBy |     |     | </br>| callCountTotal | select,
             orderBy |     |     | </br>| bandwidth | select, orderBy |     |     |
             </br>| cacheHitsCount | select |     |     | </br>| cacheMissCount |
             select |     |     | </br>| apiTimeAvg | select, orderBy |     |     |
             </br>| apiTimeMin | select |     |     | </br>| apiTimeMax | select |
             |     | </br>| serviceTimeAvg | select |     |     | </br>|
             serviceTimeMin | select |     |     | </br>| serviceTimeMax | select |
             |     | </br>
            :type filter: str
            :param top: Number of records to return.
            :type top: int
            :param skip: Number of records to skip.
            :type skip: int
            :param orderby: OData order by query option.
            :type orderby: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of ReportRecordContract
            :rtype:
             ~azure.mgmt.apimanagement.models.ReportRecordContractPaged[~azure.mgmt.apimanagement.models.ReportRecordContract]
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list_by_user.metadata['url']
                    path_format_arguments = {
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                        'serviceName': self._serialize.url("service_name", service_name, 'str', max_length=50, min_length=1, pattern=r'^[a-zA-Z](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?$'),
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    query_parameters['$filter'] = self._serialize.query("filter", filter, 'str')
                    if top is not None:
                        query_parameters['$top'] = self._serialize.query("top", top, 'int', minimum=1)
                    if skip is not None:
                        query_parameters['$skip'] = self._serialize.query("skip", skip, 'int', minimum=0)
                    if orderby is not None:
                        query_parameters['$orderby'] = self._serialize.query("orderby", orderby, 'str')
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Accept'] = 'application/json'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters, header_parameters)
                response = self._client.send(request, stream=False, **operation_config)

                if response.status_code not in [200]:
                    exp = CloudError(response)
                    exp.request_id = response.headers.get('x-ms-request-id')
                    raise exp

                return response

            # Deserialize response
            deserialized = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list_by_user.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ApiManagement/service/{serviceName}/reports/byUser'}

        def list_by_operation(
                self, resource_group_name, service_name, filter, top=None, skip=None, orderby=None, custom_headers=None, raw=False, **operation_config):
            """Lists report records by API Operations.

            :param resource_group_name: The name of the resource group.
            :type resource_group_name: str
            :param service_name: The name of the API Management service.
            :type service_name: str
            :param filter: |   Field     |     Usage     |     Supported operators
             |     Supported functions
             |</br>|-------------|-------------|-------------|-------------|</br>|
             timestamp | filter | ge, le |     | </br>| displayName | select,
             orderBy |     |     | </br>| apiRegion | filter | eq |     | </br>|
             userId | filter | eq |     | </br>| productId | filter | eq |     |
             </br>| subscriptionId | filter | eq |     | </br>| apiId | filter | eq
             |     | </br>| operationId | select, filter | eq |     | </br>|
             callCountSuccess | select, orderBy |     |     | </br>|
             callCountBlocked | select, orderBy |     |     | </br>|
             callCountFailed | select, orderBy |     |     | </br>| callCountOther
             | select, orderBy |     |     | </br>| callCountTotal | select,
             orderBy |     |     | </br>| bandwidth | select, orderBy |     |     |
             </br>| cacheHitsCount | select |     |     | </br>| cacheMissCount |
             select |     |     | </br>| apiTimeAvg | select, orderBy |     |     |
             </br>| apiTimeMin | select |     |     | </br>| apiTimeMax | select |
             |     | </br>| serviceTimeAvg | select |     |     | </br>|
             serviceTimeMin | select |     |     | </br>| serviceTimeMax | select |
             |     | </br>
            :type filter: str
            :param top: Number of records to return.
            :type top: int
            :param skip: Number of records to skip.
            :type skip: int
            :param orderby: OData order by query option.
            :type orderby: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of ReportRecordContract
            :rtype:
             ~azure.mgmt.apimanagement.models.ReportRecordContractPaged[~azure.mgmt.apimanagement.models.ReportRecordContract]
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list_by_operation.metadata['url']
                    path_format_arguments = {
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                        'serviceName': self._serialize.url("service_name", service_name, 'str', max_length=50, min_length=1, pattern=r'^[a-zA-Z](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?$'),
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    query_parameters['$filter'] = self._serialize.query("filter", filter, 'str')
                    if top is not None:
                        query_parameters['$top'] = self._serialize.query("top", top, 'int', minimum=1)
                    if skip is not None:
                        query_parameters['$skip'] = self._serialize.query("skip", skip, 'int', minimum=0)
                    if orderby is not None:
                        query_parameters['$orderby'] = self._serialize.query("orderby", orderby, 'str')
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Accept'] = 'application/json'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters, header_parameters)
                response = self._client.send(request, stream=False, **operation_config)

                if response.status_code not in [200]:
                    exp = CloudError(response)
                    exp.request_id = response.headers.get('x-ms-request-id')
                    raise exp

                return response

            # Deserialize response
            deserialized = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list_by_operation.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ApiManagement/service/{serviceName}/reports/byOperation'}

        def list_by_product(
                self, resource_group_name, service_name, filter, top=None, skip=None, orderby=None, custom_headers=None, raw=False, **operation_config):
            """Lists report records by Product.

            :param resource_group_name: The name of the resource group.
            :type resource_group_name: str
            :param service_name: The name of the API Management service.
            :type service_name: str
            :param filter: |   Field     |     Usage     |     Supported operators
             |     Supported functions
             |</br>|-------------|-------------|-------------|-------------|</br>|
             timestamp | filter | ge, le |     | </br>| displayName | select,
             orderBy |     |     | </br>| apiRegion | filter | eq |     | </br>|
             userId | filter | eq |     | </br>| productId | select, filter | eq |
             | </br>| subscriptionId | filter | eq |     | </br>| callCountSuccess
             | select, orderBy |     |     | </br>| callCountBlocked | select,
             orderBy |     |     | </br>| callCountFailed | select, orderBy |     |
             | </br>| callCountOther | select, orderBy |     |     | </br>|
             callCountTotal | select, orderBy |     |     | </br>| bandwidth |
             select, orderBy |     |     | </br>| cacheHitsCount | select |     |
             | </br>| cacheMissCount | select |     |     | </br>| apiTimeAvg |
             select, orderBy |     |     | </br>| apiTimeMin | select |     |     |
             </br>| apiTimeMax | select |     |     | </br>| serviceTimeAvg |
             select |     |     | </br>| serviceTimeMin | select |     |     |
             </br>| serviceTimeMax | select |     |     | </br>
            :type filter: str
            :param top: Number of records to return.
            :type top: int
            :param skip: Number of records to skip.
            :type skip: int
            :param orderby: OData order by query option.
            :type orderby: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of ReportRecordContract
            :rtype:
             ~azure.mgmt.apimanagement.models.ReportRecordContractPaged[~azure.mgmt.apimanagement.models.ReportRecordContract]
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list_by_product.metadata['url']
                    path_format_arguments = {
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                        'serviceName': self._serialize.url("service_name", service_name, 'str', max_length=50, min_length=1, pattern=r'^[a-zA-Z](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?$'),
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    query_parameters['$filter'] = self._serialize.query("filter", filter, 'str')
                    if top is not None:
                        query_parameters['$top'] = self._serialize.query("top", top, 'int', minimum=1)
                    if skip is not None:
                        query_parameters['$skip'] = self._serialize.query("skip", skip, 'int', minimum=0)
                    if orderby is not None:
                        query_parameters['$orderby'] = self._serialize.query("orderby", orderby, 'str')
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Accept'] = 'application/json'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters, header_parameters)
                response = self._client.send(request, stream=False, **operation_config)

                if response.status_code not in [200]:
                    exp = CloudError(response)
                    exp.request_id = response.headers.get('x-ms-request-id')
                    raise exp

                return response

            # Deserialize response
            deserialized = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list_by_product.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ApiManagement/service/{serviceName}/reports/byProduct'}

        def list_by_geo(
                self, resource_group_name, service_name, filter, top=None, skip=None, custom_headers=None, raw=False, **operation_config):
            """Lists report records by geography.

            :param resource_group_name: The name of the resource group.
            :type resource_group_name: str
            :param service_name: The name of the API Management service.
            :type service_name: str
            :param filter: |   Field     |     Usage     |     Supported operators
             |     Supported functions
             |</br>|-------------|-------------|-------------|-------------|</br>|
             timestamp | filter | ge, le |     | </br>| country | select |     |
             | </br>| region | select |     |     | </br>| zip | select |     |
             | </br>| apiRegion | filter | eq |     | </br>| userId | filter | eq |
             | </br>| productId | filter | eq |     | </br>| subscriptionId |
             filter | eq |     | </br>| apiId | filter | eq |     | </br>|
             operationId | filter | eq |     | </br>| callCountSuccess | select |
             |     | </br>| callCountBlocked | select |     |     | </br>|
             callCountFailed | select |     |     | </br>| callCountOther | select
             |     |     | </br>| bandwidth | select, orderBy |     |     | </br>|
             cacheHitsCount | select |     |     | </br>| cacheMissCount | select |
             |     | </br>| apiTimeAvg | select |     |     | </br>| apiTimeMin |
             select |     |     | </br>| apiTimeMax | select |     |     | </br>|
             serviceTimeAvg | select |     |     | </br>| serviceTimeMin | select |
             |     | </br>| serviceTimeMax | select |     |     | </br>
            :type filter: str
            :param top: Number of records to return.
            :type top: int
            :param skip: Number of records to skip.
            :type skip: int
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of ReportRecordContract
            :rtype:
             ~azure.mgmt.apimanagement.models.ReportRecordContractPaged[~azure.mgmt.apimanagement.models.ReportRecordContract]
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list_by_geo.metadata['url']
                    path_format_arguments = {
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                        'serviceName': self._serialize.url("service_name", service_name, 'str', max_length=50, min_length=1, pattern=r'^[a-zA-Z](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?$'),
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    query_parameters['$filter'] = self._serialize.query("filter", filter, 'str')
                    if top is not None:
                        query_parameters['$top'] = self._serialize.query("top", top, 'int', minimum=1)
                    if skip is not None:
                        query_parameters['$skip'] = self._serialize.query("skip", skip, 'int', minimum=0)
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Accept'] = 'application/json'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters, header_parameters)
                response = self._client.send(request, stream=False, **operation_config)

                if response.status_code not in [200]:
                    exp = CloudError(response)
                    exp.request_id = response.headers.get('x-ms-request-id')
                    raise exp

                return response

            # Deserialize response
            deserialized = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list_by_geo.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ApiManagement/service/{serviceName}/reports/byGeo'}

        def list_by_subscription(
                self, resource_group_name, service_name, filter, top=None, skip=None, orderby=None, custom_headers=None, raw=False, **operation_config):
            """Lists report records by subscription.

            :param resource_group_name: The name of the resource group.
            :type resource_group_name: str
            :param service_name: The name of the API Management service.
            :type service_name: str
            :param filter: |   Field     |     Usage     |     Supported operators
             |     Supported functions
             |</br>|-------------|-------------|-------------|-------------|</br>|
             timestamp | filter | ge, le |     | </br>| displayName | select,
             orderBy |     |     | </br>| apiRegion | filter | eq |     | </br>|
             userId | select, filter | eq |     | </br>| productId | select, filter
             | eq |     | </br>| subscriptionId | select, filter | eq |     |
             </br>| callCountSuccess | select, orderBy |     |     | </br>|
             callCountBlocked | select, orderBy |     |     | </br>|
             callCountFailed | select, orderBy |     |     | </br>| callCountOther
             | select, orderBy |     |     | </br>| callCountTotal | select,
             orderBy |     |     | </br>| bandwidth | select, orderBy |     |     |
             </br>| cacheHitsCount | select |     |     | </br>| cacheMissCount |
             select |     |     | </br>| apiTimeAvg | select, orderBy |     |     |
             </br>| apiTimeMin | select |     |     | </br>| apiTimeMax | select |
             |     | </br>| serviceTimeAvg | select |     |     | </br>|
             serviceTimeMin | select |     |     | </br>| serviceTimeMax | select |
             |     | </br>
            :type filter: str
            :param top: Number of records to return.
            :type top: int
            :param skip: Number of records to skip.
            :type skip: int
            :param orderby: OData order by query option.
            :type orderby: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of ReportRecordContract
            :rtype:
             ~azure.mgmt.apimanagement.models.ReportRecordContractPaged[~azure.mgmt.apimanagement.models.ReportRecordContract]
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list_by_subscription.metadata['url']
                    path_format_arguments = {
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                        'serviceName': self._serialize.url("service_name", service_name, 'str', max_length=50, min_length=1, pattern=r'^[a-zA-Z](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?$'),
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    query_parameters['$filter'] = self._serialize.query("filter", filter, 'str')
                    if top is not None:
                        query_parameters['$top'] = self._serialize.query("top", top, 'int', minimum=1)
                    if skip is not None:
                        query_parameters['$skip'] = self._serialize.query("skip", skip, 'int', minimum=0)
                    if orderby is not None:
                        query_parameters['$orderby'] = self._serialize.query("orderby", orderby, 'str')
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Accept'] = 'application/json'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters, header_parameters)
                response = self._client.send(request, stream=False, **operation_config)

                if response.status_code not in [200]:
                    exp = CloudError(response)
                    exp.request_id = response.headers.get('x-ms-request-id')
                    raise exp

                return response

            # Deserialize response
            deserialized = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list_by_subscription.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ApiManagement/service/{serviceName}/reports/bySubscription'}

        def list_by_time(
                self, resource_group_name, service_name, filter, interval, top=None, skip=None, orderby=None, custom_headers=None, raw=False, **operation_config):
            """Lists report records by Time.

            :param resource_group_name: The name of the resource group.
            :type resource_group_name: str
            :param service_name: The name of the API Management service.
            :type service_name: str
            :param filter: |   Field     |     Usage     |     Supported operators
             |     Supported functions
             |</br>|-------------|-------------|-------------|-------------|</br>|
             timestamp | filter, select | ge, le |     | </br>| interval | select |
             |     | </br>| apiRegion | filter | eq |     | </br>| userId | filter
             | eq |     | </br>| productId | filter | eq |     | </br>|
             subscriptionId | filter | eq |     | </br>| apiId | filter | eq |
             | </br>| operationId | filter | eq |     | </br>| callCountSuccess |
             select |     |     | </br>| callCountBlocked | select |     |     |
             </br>| callCountFailed | select |     |     | </br>| callCountOther |
             select |     |     | </br>| bandwidth | select, orderBy |     |     |
             </br>| cacheHitsCount | select |     |     | </br>| cacheMissCount |
             select |     |     | </br>| apiTimeAvg | select |     |     | </br>|
             apiTimeMin | select |     |     | </br>| apiTimeMax | select |     |
             | </br>| serviceTimeAvg | select |     |     | </br>| serviceTimeMin |
             select |     |     | </br>| serviceTimeMax | select |     |     |
             </br>
            :type filter: str
            :param interval: By time interval. Interval must be multiple of 15
             minutes and may not be zero. The value should be in ISO  8601 format
             (http://en.wikipedia.org/wiki/ISO_8601#Durations).This code can be
             used to convert TimeSpan to a valid interval string:
             XmlConvert.ToString(new TimeSpan(hours, minutes, seconds)).
            :type interval: timedelta
            :param top: Number of records to return.
            :type top: int
            :param skip: Number of records to skip.
            :type skip: int
            :param orderby: OData order by query option.
            :type orderby: str
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of ReportRecordContract
            :rtype:
             ~azure.mgmt.apimanagement.models.ReportRecordContractPaged[~azure.mgmt.apimanagement.models.ReportRecordContract]
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list_by_time.metadata['url']
                    path_format_arguments = {
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                        'serviceName': self._serialize.url("service_name", service_name, 'str', max_length=50, min_length=1, pattern=r'^[a-zA-Z](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?$'),
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    query_parameters['$filter'] = self._serialize.query("filter", filter, 'str')
                    if top is not None:
                        query_parameters['$top'] = self._serialize.query("top", top, 'int', minimum=1)
                    if skip is not None:
                        query_parameters['$skip'] = self._serialize.query("skip", skip, 'int', minimum=0)
                    if orderby is not None:
                        query_parameters['$orderby'] = self._serialize.query("orderby", orderby, 'str')
                    query_parameters['interval'] = self._serialize.query("interval", interval, 'duration')
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Accept'] = 'application/json'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters, header_parameters)
                response = self._client.send(request, stream=False, **operation_config)

                if response.status_code not in [200]:
                    exp = CloudError(response)
                    exp.request_id = response.headers.get('x-ms-request-id')
                    raise exp

                return response

            # Deserialize response
            deserialized = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.ReportRecordContractPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list_by_time.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ApiManagement/service/{serviceName}/reports/byTime'}

        def list_by_request(
                self, resource_group_name, service_name, filter, top=None, skip=None, custom_headers=None, raw=False, **operation_config):
            """Lists report records by Request.

            :param resource_group_name: The name of the resource group.
            :type resource_group_name: str
            :param service_name: The name of the API Management service.
            :type service_name: str
            :param filter: |   Field     |     Usage     |     Supported operators
             |     Supported functions
             |</br>|-------------|-------------|-------------|-------------|</br>|
             timestamp | filter | ge, le |     | </br>| apiId | filter | eq |     |
             </br>| operationId | filter | eq |     | </br>| productId | filter |
             eq |     | </br>| userId | filter | eq |     | </br>| apiRegion |
             filter | eq |     | </br>| subscriptionId | filter | eq |     | </br>
            :type filter: str
            :param top: Number of records to return.
            :type top: int
            :param skip: Number of records to skip.
            :type skip: int
            :param dict custom_headers: headers that will be added to the request
            :param bool raw: returns the direct response alongside the
             deserialized response
            :param operation_config: :ref:`Operation configuration
             overrides<msrest:optionsforoperations>`.
            :return: An iterator like instance of RequestReportRecordContract
            :rtype:
             ~azure.mgmt.apimanagement.models.RequestReportRecordContractPaged[~azure.mgmt.apimanagement.models.RequestReportRecordContract]
            :raises: :class:`CloudError<msrestazure.azure_exceptions.CloudError>`
            """
            def internal_paging(next_link=None, raw=False):

                if not next_link:
                    # Construct URL
                    url = self.list_by_request.metadata['url']
                    path_format_arguments = {
                        'resourceGroupName': self._serialize.url("resource_group_name", resource_group_name, 'str'),
                        'serviceName': self._serialize.url("service_name", service_name, 'str', max_length=50, min_length=1, pattern=r'^[a-zA-Z](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?$'),
                        'subscriptionId': self._serialize.url("self.config.subscription_id", self.config.subscription_id, 'str')
                    }
                    url = self._client.format_url(url, **path_format_arguments)

                    # Construct parameters
                    query_parameters = {}
                    query_parameters['$filter'] = self._serialize.query("filter", filter, 'str')
                    if top is not None:
                        query_parameters['$top'] = self._serialize.query("top", top, 'int', minimum=1)
                    if skip is not None:
                        query_parameters['$skip'] = self._serialize.query("skip", skip, 'int', minimum=0)
                    query_parameters['api-version'] = self._serialize.query("self.api_version", self.api_version, 'str')

                else:
                    url = next_link
                    query_parameters = {}

                # Construct headers
                header_parameters = {}
                header_parameters['Accept'] = 'application/json'
                if self.config.generate_client_request_id:
                    header_parameters['x-ms-client-request-id'] = str(uuid.uuid1())
                if custom_headers:
                    header_parameters.update(custom_headers)
                if self.config.accept_language is not None:
                    header_parameters['accept-language'] = self._serialize.header("self.config.accept_language", self.config.accept_language, 'str')

                # Construct and send request
                request = self._client.get(url, query_parameters, header_parameters)
                response = self._client.send(request, stream=False, **operation_config)

                if response.status_code not in [200]:
                    exp = CloudError(response)
                    exp.request_id = response.headers.get('x-ms-request-id')
                    raise exp

                return response

            # Deserialize response
            deserialized = models.RequestReportRecordContractPaged(internal_paging, self._deserialize.dependencies)

            if raw:
                header_dict = {}
                client_raw_response = models.RequestReportRecordContractPaged(internal_paging, self._deserialize.dependencies, header_dict)
                return client_raw_response

            return deserialized
        list_by_request.metadata = {'url': '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ApiManagement/service/{serviceName}/reports/byRequest'}